> For the complete documentation index, see [llms.txt](https://docs.algebra.finance/algebra-integral-documentation/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.algebra.finance/algebra-integral-documentation/algebra-v1-technical-reference/contracts/api-reference-v1.0/v1.0-periphery/quoterv2.md).

# QuoterV2

Provides quotes for swaps Allows getting the expected amount out or amount in for a given swap without executing the swap *Developer note: These functions are not gas efficient and should not be called on chain. Instead, optimistically execute the swap and check the amounts in the callback.*

## Functions

### constructor

PeripheryImmutableState

`constructor(address,address,address)` public

| Name           | Type    | Description |
| -------------- | ------- | ----------- |
| \_factory      | address |             |
| \_WNativeToken | address |             |
| \_poolDeployer | address |             |

### algebraSwapCallback

`algebraSwapCallback(int256,int256,bytes)` view external

Called to \`msg.sender\` after executing a swap via IAlgebraPool#swap.

| Name         | Type   | Description                                                                                                                                                                             |
| ------------ | ------ | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| amount0Delta | int256 | The amount of token0 that was sent (negative) or must be received (positive) by the pool by the end of the swap. If positive, the callback must send that amount of token0 to the pool. |
| amount1Delta | int256 | The amount of token1 that was sent (negative) or must be received (positive) by the pool by the end of the swap. If positive, the callback must send that amount of token1 to the pool. |
| path         | bytes  |                                                                                                                                                                                         |

### quoteExactInputSingle

`quoteExactInputSingle(struct IQuoterV2.QuoteExactInputSingleParams)` public

| Name   | Type                                         | Description |
| ------ | -------------------------------------------- | ----------- |
| params | struct IQuoterV2.QuoteExactInputSingleParams |             |

**Returns:**

| Name                    | Type    | Description |
| ----------------------- | ------- | ----------- |
| amountOut               | uint256 |             |
| sqrtPriceX96After       | uint160 |             |
| initializedTicksCrossed | uint32  |             |
| gasEstimate             | uint256 |             |

### quoteExactInput

`quoteExactInput(bytes,uint256)` public

| Name     | Type    | Description |
| -------- | ------- | ----------- |
| path     | bytes   |             |
| amountIn | uint256 |             |

**Returns:**

| Name                        | Type       | Description |
| --------------------------- | ---------- | ----------- |
| amountOut                   | uint256    |             |
| sqrtPriceX96AfterList       | uint160\[] |             |
| initializedTicksCrossedList | uint32\[]  |             |
| gasEstimate                 | uint256    |             |

### quoteExactOutputSingle

`quoteExactOutputSingle(struct IQuoterV2.QuoteExactOutputSingleParams)` public

| Name   | Type                                          | Description |
| ------ | --------------------------------------------- | ----------- |
| params | struct IQuoterV2.QuoteExactOutputSingleParams |             |

**Returns:**

| Name                    | Type    | Description |
| ----------------------- | ------- | ----------- |
| amountIn                | uint256 |             |
| sqrtPriceX96After       | uint160 |             |
| initializedTicksCrossed | uint32  |             |
| gasEstimate             | uint256 |             |

### quoteExactOutput

`quoteExactOutput(bytes,uint256)` public

| Name      | Type    | Description |
| --------- | ------- | ----------- |
| path      | bytes   |             |
| amountOut | uint256 |             |

**Returns:**

| Name                        | Type       | Description |
| --------------------------- | ---------- | ----------- |
| amountIn                    | uint256    |             |
| sqrtPriceX96AfterList       | uint160\[] |             |
| initializedTicksCrossedList | uint32\[]  |             |
| gasEstimate                 | uint256    |             |

***


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.algebra.finance/algebra-integral-documentation/algebra-v1-technical-reference/contracts/api-reference-v1.0/v1.0-periphery/quoterv2.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
